<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">

    <title>Bootstrap Flex</title>
  </head>
  <body>
    <h1 class="text-center">Bootstrap Flex</h1>
    <h5 class="text-center">Bootstrap > Utilities > Flex</h5>
    <p class="text-center">Use the d-flex to create a flex container and transform direct children into flex items.</p>

    <!-- direction
      flex-row  *default*
      flex-column
      flex-row-reverse
      flex-column-reverse
    -->
      
    <!-- justify-content
      justify-content-start *default*
      justify-content-end
      justify-content-center
      justify-content-between
      justify-content-evenly
     -->

    <!-- align-items 
      align-items-start
      align-items-end
      align-items-center
      align-items-baseline
      align-items-stretch *default*
    -->

    <!-- flex-wrap
      flex-nowrap default
      flex-wrap
      flex-wrap-reverse
    -->

    <!-- align-content 
      align-content-start
      align-content-end
      align-content-center
      align-content-around *default*
      align-content-between
      align-content-stretch
    -->



    <div style="height: 300px;" class="
      bg-secondary 
      p-3 
      d-flex flex-row justify-content-center align-items-center flex-wrap align-content-around
    ">
      <div class="bg-success p-3">Flex Item A</div>
      <div class="bg-warning p-3">Flex Item B</div>
      <div class="bg-danger p-3">Flex Item C</div>
      <div class="bg-success p-3">Flex Item D</div>
      <div class="bg-warning p-3">Flex Item E</div>
      <div class="bg-danger p-3">Flex Item F</div>
      <div class="bg-success p-3">Flex Item G</div>
      <div class="bg-warning p-3">Flex Item H</div>
      <div class="bg-danger p-3">Flex Item I</div>
      <div class="bg-success p-3">Flex Item J</div>
      <div class="bg-warning p-3">Flex Item K</div>
      <div class="bg-danger p-3">Flex Item L</div>
    </div>



    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: jQuery and Bootstrap Bundle (includes Popper) -->
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>

    <!-- Option 2: Separate Popper and Bootstrap JS -->
    <!--
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.min.js" integrity="sha384-VHvPCCyXqtD5DqJeNxl2dtTyhF78xXNXdkwX1CZeRusQfRKp+tA7hAShOK/B/fQ2" crossorigin="anonymous"></script>
    -->
  </body>
</html>